/* THIS FILE IS AUTOGENERATED FROM MatchPattern.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_MatchPatternBinding_h
#define mozilla_dom_MatchPatternBinding_h

#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/UnionMember.h"

namespace mozilla {

namespace dom {

struct MatchPatternOptionsAtoms;
struct NativePropertyHooks;
class OwningStringOrMatchPattern;
class ProtoAndIfaceCache;

} // namespace dom

namespace extensions {

class MatchPattern;
struct MatchPatternAtoms;
class MatchPatternSet;
struct MatchPatternSetAtoms;

} // namespace extensions

} // namespace mozilla

namespace mozilla {
namespace dom {

void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningStringOrMatchPattern& aUnion, const char* aName, uint32_t aFlags = 0);


void
ImplCycleCollectionUnlink(OwningStringOrMatchPattern& aUnion);


struct MatchPatternOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR bool mIgnorePath;
  MOZ_INIT_OUTSIDE_CTOR bool mRestrictSchemes;

  MatchPatternOptions();

  explicit inline MatchPatternOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline MatchPatternOptions(const MatchPatternOptions& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  MatchPatternOptions&
  operator=(const MatchPatternOptions& aOther);

  bool
  operator==(const MatchPatternOptions& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, MatchPatternOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastMatchPatternOptions : public MatchPatternOptions
{
  inline FastMatchPatternOptions()
    : MatchPatternOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class StringOrMatchPattern
{
  friend class StringOrMatchPatternArgument;
  enum Type
  {
    eUninitialized,
    eString,
    eMatchPattern
  };

  union Value
  {
    UnionMember<binding_detail::FakeString<char16_t> > mString;
    UnionMember<NonNull<mozilla::extensions::MatchPattern> > mMatchPattern;

  };

  Type mType;
  Value mValue;

  StringOrMatchPattern(const StringOrMatchPattern&) = delete;
  StringOrMatchPattern& operator=(const StringOrMatchPattern&) = delete;
public:
  explicit inline StringOrMatchPattern()
    : mType(eUninitialized)
  {
  }

  inline ~StringOrMatchPattern()
  {
    Uninit();
  }

  inline binding_detail::FakeString<char16_t>&
  RawSetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline binding_detail::FakeString<char16_t>&
  SetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    Uninit();
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline binding_detail::FakeString<char16_t>&
  GetAsString()
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline const nsAString&
  GetAsString() const
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline NonNull<mozilla::extensions::MatchPattern>&
  RawSetAsMatchPattern()
  {
    if (mType == eMatchPattern) {
      return mValue.mMatchPattern.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eMatchPattern;
    return mValue.mMatchPattern.SetValue();
  }

  inline NonNull<mozilla::extensions::MatchPattern>&
  SetAsMatchPattern()
  {
    if (mType == eMatchPattern) {
      return mValue.mMatchPattern.Value();
    }
    Uninit();
    mType = eMatchPattern;
    return mValue.mMatchPattern.SetValue();
  }

  inline bool
  IsMatchPattern() const
  {
    return mType == eMatchPattern;
  }

  inline NonNull<mozilla::extensions::MatchPattern>&
  GetAsMatchPattern()
  {
    MOZ_ASSERT(IsMatchPattern(), "Wrong type!");
    return mValue.mMatchPattern.Value();
  }

  inline mozilla::extensions::MatchPattern&
  GetAsMatchPattern() const
  {
    MOZ_ASSERT(IsMatchPattern(), "Wrong type!");
    return mValue.mMatchPattern.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eString: {
        DestroyString();
        break;
      }
      case eMatchPattern: {
        DestroyMatchPattern();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyString()
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    mValue.mString.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyMatchPattern()
  {
    MOZ_ASSERT(IsMatchPattern(), "Wrong type!");
    mValue.mMatchPattern.Destroy();
    mType = eUninitialized;
  }
};


class OwningStringOrMatchPattern : public AllOwningUnionBase
{
  friend void ImplCycleCollectionUnlink(OwningStringOrMatchPattern& aUnion);
  enum Type
  {
    eUninitialized,
    eString,
    eMatchPattern
  };

  union Value
  {
    UnionMember<nsString > mString;
    UnionMember<OwningNonNull<mozilla::extensions::MatchPattern> > mMatchPattern;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningStringOrMatchPattern()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningStringOrMatchPattern(const OwningStringOrMatchPattern& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningStringOrMatchPattern()
  {
    Uninit();
  }

  nsString&
  RawSetAsString();

  nsString&
  SetAsString();

  bool
  TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  template <int N>
  inline void
  SetStringLiteral(const nsString::char_type (&aData)[N])
  {
    RawSetAsString().AssignLiteral(aData);
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline nsString&
  GetAsString()
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline nsString const &
  GetAsString() const
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  OwningNonNull<mozilla::extensions::MatchPattern>&
  RawSetAsMatchPattern();

  OwningNonNull<mozilla::extensions::MatchPattern>&
  SetAsMatchPattern();

  bool
  TrySetToMatchPattern(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToMatchPattern(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsMatchPattern() const
  {
    return mType == eMatchPattern;
  }

  inline OwningNonNull<mozilla::extensions::MatchPattern>&
  GetAsMatchPattern()
  {
    MOZ_ASSERT(IsMatchPattern(), "Wrong type!");
    return mValue.mMatchPattern.Value();
  }

  inline OwningNonNull<mozilla::extensions::MatchPattern> const &
  GetAsMatchPattern() const
  {
    MOZ_ASSERT(IsMatchPattern(), "Wrong type!");
    return mValue.mMatchPattern.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceUnion(JSTracer* trc);

  OwningStringOrMatchPattern&
  operator=(const OwningStringOrMatchPattern& aOther);

private:
  void
  DestroyString();

  void
  DestroyMatchPattern();
};


namespace MatchPattern_Binding {

  typedef mozilla::extensions::MatchPattern NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::extensions::MatchPattern* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::MatchPattern,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::MatchPattern,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace MatchPattern_Binding



namespace MatchPatternSet_Binding {

  typedef mozilla::extensions::MatchPatternSet NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::extensions::MatchPatternSet* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::MatchPatternSet,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::MatchPatternSet,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace MatchPatternSet_Binding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_MatchPatternBinding_h
