struct cs_clip_image_TEXTURE_2D_common {
struct Samplers {
 sampler2D_impl sColor0_impl;
 int sColor0_slot;
 sampler2D_impl sGpuCache_impl;
 int sGpuCache_slot;
 sampler2D_impl sRenderTasks_impl;
 int sRenderTasks_slot;
 sampler2D_impl sTransformPalette_impl;
 int sTransformPalette_slot;
 bool set_slot(int index, int value) {
  switch (index) {
  case 5:
   sColor0_slot = value;
   return true;
  case 2:
   sGpuCache_slot = value;
   return true;
  case 1:
   sRenderTasks_slot = value;
   return true;
  case 3:
   sTransformPalette_slot = value;
   return true;
  }
  return false;
 }
} samplers;
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aClipDeviceArea = NULL_ATTRIB;
 int aClipOrigins = NULL_ATTRIB;
 int aDevicePixelScale = NULL_ATTRIB;
 int aTransformIds = NULL_ATTRIB;
 int aClipTileRect = NULL_ATTRIB;
 int aClipDataResourceAddress = NULL_ATTRIB;
 int aClipLocalRect = NULL_ATTRIB;
 void bind_loc(const char* name, int index) {
  if (strcmp("aPosition", name) == 0) { aPosition = index; return; }
  if (strcmp("aClipDeviceArea", name) == 0) { aClipDeviceArea = index; return; }
  if (strcmp("aClipOrigins", name) == 0) { aClipOrigins = index; return; }
  if (strcmp("aDevicePixelScale", name) == 0) { aDevicePixelScale = index; return; }
  if (strcmp("aTransformIds", name) == 0) { aTransformIds = index; return; }
  if (strcmp("aClipTileRect", name) == 0) { aClipTileRect = index; return; }
  if (strcmp("aClipDataResourceAddress", name) == 0) { aClipDataResourceAddress = index; return; }
  if (strcmp("aClipLocalRect", name) == 0) { aClipLocalRect = index; return; }
 }
 int get_loc(const char* name) const {
  if (strcmp("aPosition", name) == 0) { return aPosition != NULL_ATTRIB ? aPosition : -1; }
  if (strcmp("aClipDeviceArea", name) == 0) { return aClipDeviceArea != NULL_ATTRIB ? aClipDeviceArea : -1; }
  if (strcmp("aClipOrigins", name) == 0) { return aClipOrigins != NULL_ATTRIB ? aClipOrigins : -1; }
  if (strcmp("aDevicePixelScale", name) == 0) { return aDevicePixelScale != NULL_ATTRIB ? aDevicePixelScale : -1; }
  if (strcmp("aTransformIds", name) == 0) { return aTransformIds != NULL_ATTRIB ? aTransformIds : -1; }
  if (strcmp("aClipTileRect", name) == 0) { return aClipTileRect != NULL_ATTRIB ? aClipTileRect : -1; }
  if (strcmp("aClipDataResourceAddress", name) == 0) { return aClipDataResourceAddress != NULL_ATTRIB ? aClipDataResourceAddress : -1; }
  if (strcmp("aClipLocalRect", name) == 0) { return aClipLocalRect != NULL_ATTRIB ? aClipLocalRect : -1; }
  return -1;
 }
} attrib_locations;
vec4_scalar vTransformBounds;
vec4_scalar vClipMaskUvInnerRect;
sampler2D sColor0;
sampler2D sGpuCache;
sampler2D sRenderTasks;
sampler2D sTransformPalette;
mat4_scalar uTransform;
void bind_textures() {
 sColor0 = lookup_sampler(&samplers.sColor0_impl, samplers.sColor0_slot);
 sGpuCache = lookup_sampler(&samplers.sGpuCache_impl, samplers.sGpuCache_slot);
 sRenderTasks = lookup_sampler(&samplers.sRenderTasks_impl, samplers.sRenderTasks_slot);
 sTransformPalette = lookup_sampler(&samplers.sTransformPalette_impl, samplers.sTransformPalette_slot);
}
};
struct cs_clip_image_TEXTURE_2D_vert : VertexShaderImpl, cs_clip_image_TEXTURE_2D_common {
private:
typedef cs_clip_image_TEXTURE_2D_vert Self;
// int32_t uMode;
// mat4_scalar uTransform;
vec2 aPosition;
// sampler2D sColor0;
// sampler2D sColor1;
// sampler2D sColor2;
struct RectWithSize_scalar {
vec2_scalar p0;
vec2_scalar size;
RectWithSize_scalar() = default;
RectWithSize_scalar(vec2_scalar p0, vec2_scalar size) : p0(p0), size(size){}
};
struct RectWithSize {
vec2 p0;
vec2 size;
RectWithSize() = default;
RectWithSize(vec2 p0, vec2 size) : p0(p0), size(size){}
RectWithSize(vec2_scalar p0, vec2_scalar size):p0(p0),size(size){
}
IMPLICIT RectWithSize(RectWithSize_scalar s):p0(s.p0),size(s.size){
}
friend RectWithSize if_then_else(I32 c, RectWithSize t, RectWithSize e) { return RectWithSize(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.size, e.size));
}};
struct RectWithEndpoint_scalar {
vec2_scalar p0;
vec2_scalar p1;
RectWithEndpoint_scalar() = default;
RectWithEndpoint_scalar(vec2_scalar p0, vec2_scalar p1) : p0(p0), p1(p1){}
};
struct RectWithEndpoint {
vec2 p0;
vec2 p1;
RectWithEndpoint() = default;
RectWithEndpoint(vec2 p0, vec2 p1) : p0(p0), p1(p1){}
RectWithEndpoint(vec2_scalar p0, vec2_scalar p1):p0(p0),p1(p1){
}
IMPLICIT RectWithEndpoint(RectWithEndpoint_scalar s):p0(s.p0),p1(s.p1){
}
friend RectWithEndpoint if_then_else(I32 c, RectWithEndpoint t, RectWithEndpoint e) { return RectWithEndpoint(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.p1, e.p1));
}};
// sampler2D sRenderTasks;
struct RenderTaskData_scalar {
RectWithEndpoint_scalar task_rect;
vec4_scalar user_data;
RenderTaskData_scalar() = default;
RenderTaskData_scalar(RectWithEndpoint_scalar task_rect, vec4_scalar user_data) : task_rect(task_rect), user_data(user_data){}
};
struct RenderTaskData {
RectWithEndpoint task_rect;
vec4 user_data;
RenderTaskData() = default;
RenderTaskData(RectWithEndpoint task_rect, vec4 user_data) : task_rect(task_rect), user_data(user_data){}
RenderTaskData(RectWithEndpoint_scalar task_rect, vec4_scalar user_data):task_rect(task_rect),user_data(user_data){
}
IMPLICIT RenderTaskData(RenderTaskData_scalar s):task_rect(s.task_rect),user_data(s.user_data){
}
friend RenderTaskData if_then_else(I32 c, RenderTaskData t, RenderTaskData e) { return RenderTaskData(
if_then_else(c, t.task_rect, e.task_rect), if_then_else(c, t.user_data, e.user_data));
}};
struct PictureTask_scalar {
RectWithEndpoint_scalar task_rect;
float device_pixel_scale;
vec2_scalar content_origin;
PictureTask_scalar() = default;
PictureTask_scalar(RectWithEndpoint_scalar task_rect, float device_pixel_scale, vec2_scalar content_origin) : task_rect(task_rect), device_pixel_scale(device_pixel_scale), content_origin(content_origin){}
};
struct PictureTask {
RectWithEndpoint task_rect;
Float device_pixel_scale;
vec2 content_origin;
PictureTask() = default;
PictureTask(RectWithEndpoint task_rect, Float device_pixel_scale, vec2 content_origin) : task_rect(task_rect), device_pixel_scale(device_pixel_scale), content_origin(content_origin){}
PictureTask(RectWithEndpoint_scalar task_rect, float device_pixel_scale, vec2_scalar content_origin):task_rect(task_rect),device_pixel_scale(device_pixel_scale),content_origin(content_origin){
}
IMPLICIT PictureTask(PictureTask_scalar s):task_rect(s.task_rect),device_pixel_scale(s.device_pixel_scale),content_origin(s.content_origin){
}
friend PictureTask if_then_else(I32 c, PictureTask t, PictureTask e) { return PictureTask(
if_then_else(c, t.task_rect, e.task_rect), if_then_else(c, t.device_pixel_scale, e.device_pixel_scale), if_then_else(c, t.content_origin, e.content_origin));
}};
struct ClipArea_scalar {
RectWithEndpoint_scalar task_rect;
float device_pixel_scale;
vec2_scalar screen_origin;
ClipArea_scalar() = default;
ClipArea_scalar(RectWithEndpoint_scalar task_rect, float device_pixel_scale, vec2_scalar screen_origin) : task_rect(task_rect), device_pixel_scale(device_pixel_scale), screen_origin(screen_origin){}
};
struct ClipArea {
RectWithEndpoint task_rect;
Float device_pixel_scale;
vec2 screen_origin;
ClipArea() = default;
ClipArea(RectWithEndpoint task_rect, Float device_pixel_scale, vec2 screen_origin) : task_rect(task_rect), device_pixel_scale(device_pixel_scale), screen_origin(screen_origin){}
ClipArea(RectWithEndpoint_scalar task_rect, float device_pixel_scale, vec2_scalar screen_origin):task_rect(task_rect),device_pixel_scale(device_pixel_scale),screen_origin(screen_origin){
}
IMPLICIT ClipArea(ClipArea_scalar s):task_rect(s.task_rect),device_pixel_scale(s.device_pixel_scale),screen_origin(s.screen_origin){
}
friend ClipArea if_then_else(I32 c, ClipArea t, ClipArea e) { return ClipArea(
if_then_else(c, t.task_rect, e.task_rect), if_then_else(c, t.device_pixel_scale, e.device_pixel_scale), if_then_else(c, t.screen_origin, e.screen_origin));
}};
// sampler2D sGpuCache;
struct ImageSource_scalar {
RectWithEndpoint_scalar uv_rect;
vec4_scalar user_data;
ImageSource_scalar() = default;
ImageSource_scalar(RectWithEndpoint_scalar uv_rect, vec4_scalar user_data) : uv_rect(uv_rect), user_data(user_data){}
};
struct ImageSource {
RectWithEndpoint uv_rect;
vec4 user_data;
ImageSource() = default;
ImageSource(RectWithEndpoint uv_rect, vec4 user_data) : uv_rect(uv_rect), user_data(user_data){}
ImageSource(RectWithEndpoint_scalar uv_rect, vec4_scalar user_data):uv_rect(uv_rect),user_data(user_data){
}
IMPLICIT ImageSource(ImageSource_scalar s):uv_rect(s.uv_rect),user_data(s.user_data){
}
friend ImageSource if_then_else(I32 c, ImageSource t, ImageSource e) { return ImageSource(
if_then_else(c, t.uv_rect, e.uv_rect), if_then_else(c, t.user_data, e.user_data));
}};
struct ImageSourceExtra_scalar {
vec4_scalar st_tl;
vec4_scalar st_tr;
vec4_scalar st_bl;
vec4_scalar st_br;
ImageSourceExtra_scalar() = default;
ImageSourceExtra_scalar(vec4_scalar st_tl, vec4_scalar st_tr, vec4_scalar st_bl, vec4_scalar st_br) : st_tl(st_tl), st_tr(st_tr), st_bl(st_bl), st_br(st_br){}
};
struct ImageSourceExtra {
vec4 st_tl;
vec4 st_tr;
vec4 st_bl;
vec4 st_br;
ImageSourceExtra() = default;
ImageSourceExtra(vec4 st_tl, vec4 st_tr, vec4 st_bl, vec4 st_br) : st_tl(st_tl), st_tr(st_tr), st_bl(st_bl), st_br(st_br){}
ImageSourceExtra(vec4_scalar st_tl, vec4_scalar st_tr, vec4_scalar st_bl, vec4_scalar st_br):st_tl(st_tl),st_tr(st_tr),st_bl(st_bl),st_br(st_br){
}
IMPLICIT ImageSourceExtra(ImageSourceExtra_scalar s):st_tl(s.st_tl),st_tr(s.st_tr),st_bl(s.st_bl),st_br(s.st_br){
}
friend ImageSourceExtra if_then_else(I32 c, ImageSourceExtra t, ImageSourceExtra e) { return ImageSourceExtra(
if_then_else(c, t.st_tl, e.st_tl), if_then_else(c, t.st_tr, e.st_tr), if_then_else(c, t.st_bl, e.st_bl), if_then_else(c, t.st_br, e.st_br));
}};
// vec4_scalar vTransformBounds;
// sampler2D sTransformPalette;
struct Transform_scalar {
mat4_scalar m;
mat4_scalar inv_m;
bool is_axis_aligned;
Transform_scalar() = default;
Transform_scalar(mat4_scalar m, mat4_scalar inv_m, bool is_axis_aligned) : m(m), inv_m(inv_m), is_axis_aligned(is_axis_aligned){}
};
struct Transform {
mat4 m;
mat4 inv_m;
Bool is_axis_aligned;
Transform() = default;
Transform(mat4 m, mat4 inv_m, Bool is_axis_aligned) : m(m), inv_m(inv_m), is_axis_aligned(is_axis_aligned){}
Transform(mat4_scalar m, mat4_scalar inv_m, bool is_axis_aligned):m(m),inv_m(inv_m),is_axis_aligned(is_axis_aligned){
}
IMPLICIT Transform(Transform_scalar s):m(s.m),inv_m(s.inv_m),is_axis_aligned(s.is_axis_aligned){
}
friend Transform if_then_else(I32 c, Transform t, Transform e) { return Transform(
if_then_else(c, t.m, e.m), if_then_else(c, t.inv_m, e.inv_m), if_then_else(c, t.is_axis_aligned, e.is_axis_aligned));
}};
vec4_scalar aClipDeviceArea;
vec4_scalar aClipOrigins;
float aDevicePixelScale;
ivec2_scalar aTransformIds;
struct ClipMaskInstanceCommon_scalar {
RectWithEndpoint_scalar sub_rect;
vec2_scalar task_origin;
vec2_scalar screen_origin;
float device_pixel_scale;
int32_t clip_transform_id;
int32_t prim_transform_id;
ClipMaskInstanceCommon_scalar() = default;
ClipMaskInstanceCommon_scalar(RectWithEndpoint_scalar sub_rect, vec2_scalar task_origin, vec2_scalar screen_origin, float device_pixel_scale, int32_t clip_transform_id, int32_t prim_transform_id) : sub_rect(sub_rect), task_origin(task_origin), screen_origin(screen_origin), device_pixel_scale(device_pixel_scale), clip_transform_id(clip_transform_id), prim_transform_id(prim_transform_id){}
};
struct ClipMaskInstanceCommon {
RectWithEndpoint sub_rect;
vec2 task_origin;
vec2 screen_origin;
Float device_pixel_scale;
I32 clip_transform_id;
I32 prim_transform_id;
ClipMaskInstanceCommon() = default;
ClipMaskInstanceCommon(RectWithEndpoint sub_rect, vec2 task_origin, vec2 screen_origin, Float device_pixel_scale, I32 clip_transform_id, I32 prim_transform_id) : sub_rect(sub_rect), task_origin(task_origin), screen_origin(screen_origin), device_pixel_scale(device_pixel_scale), clip_transform_id(clip_transform_id), prim_transform_id(prim_transform_id){}
ClipMaskInstanceCommon(RectWithEndpoint_scalar sub_rect, vec2_scalar task_origin, vec2_scalar screen_origin, float device_pixel_scale, int32_t clip_transform_id, int32_t prim_transform_id):sub_rect(sub_rect),task_origin(task_origin),screen_origin(screen_origin),device_pixel_scale(device_pixel_scale),clip_transform_id(clip_transform_id),prim_transform_id(prim_transform_id){
}
IMPLICIT ClipMaskInstanceCommon(ClipMaskInstanceCommon_scalar s):sub_rect(s.sub_rect),task_origin(s.task_origin),screen_origin(s.screen_origin),device_pixel_scale(s.device_pixel_scale),clip_transform_id(s.clip_transform_id),prim_transform_id(s.prim_transform_id){
}
friend ClipMaskInstanceCommon if_then_else(I32 c, ClipMaskInstanceCommon t, ClipMaskInstanceCommon e) { return ClipMaskInstanceCommon(
if_then_else(c, t.sub_rect, e.sub_rect), if_then_else(c, t.task_origin, e.task_origin), if_then_else(c, t.screen_origin, e.screen_origin), if_then_else(c, t.device_pixel_scale, e.device_pixel_scale), if_then_else(c, t.clip_transform_id, e.clip_transform_id), if_then_else(c, t.prim_transform_id, e.prim_transform_id));
}};
struct ClipVertexInfo_scalar {
vec4_scalar local_pos;
RectWithEndpoint_scalar clipped_local_rect;
ClipVertexInfo_scalar() = default;
ClipVertexInfo_scalar(vec4_scalar local_pos, RectWithEndpoint_scalar clipped_local_rect) : local_pos(local_pos), clipped_local_rect(clipped_local_rect){}
};
struct ClipVertexInfo {
vec4 local_pos;
RectWithEndpoint clipped_local_rect;
ClipVertexInfo() = default;
ClipVertexInfo(vec4 local_pos, RectWithEndpoint clipped_local_rect) : local_pos(local_pos), clipped_local_rect(clipped_local_rect){}
ClipVertexInfo(vec4_scalar local_pos, RectWithEndpoint_scalar clipped_local_rect):local_pos(local_pos),clipped_local_rect(clipped_local_rect){
}
IMPLICIT ClipVertexInfo(ClipVertexInfo_scalar s):local_pos(s.local_pos),clipped_local_rect(s.clipped_local_rect){
}
friend ClipVertexInfo if_then_else(I32 c, ClipVertexInfo t, ClipVertexInfo e) { return ClipVertexInfo(
if_then_else(c, t.local_pos, e.local_pos), if_then_else(c, t.clipped_local_rect, e.clipped_local_rect));
}};
vec2 vLocalPos;
vec2 vClipMaskImageUv;
// vec4_scalar vClipMaskUvInnerRect;
vec4_scalar aClipTileRect;
ivec2_scalar aClipDataResourceAddress;
vec4_scalar aClipLocalRect;
struct ClipMaskInstanceImage_scalar {
ClipMaskInstanceCommon_scalar base;
RectWithEndpoint_scalar tile_rect;
ivec2_scalar resource_address;
RectWithEndpoint_scalar local_rect;
ClipMaskInstanceImage_scalar() = default;
ClipMaskInstanceImage_scalar(ClipMaskInstanceCommon_scalar base, RectWithEndpoint_scalar tile_rect, ivec2_scalar resource_address, RectWithEndpoint_scalar local_rect) : base(base), tile_rect(tile_rect), resource_address(resource_address), local_rect(local_rect){}
};
struct ClipMaskInstanceImage {
ClipMaskInstanceCommon base;
RectWithEndpoint tile_rect;
ivec2 resource_address;
RectWithEndpoint local_rect;
ClipMaskInstanceImage() = default;
ClipMaskInstanceImage(ClipMaskInstanceCommon base, RectWithEndpoint tile_rect, ivec2 resource_address, RectWithEndpoint local_rect) : base(base), tile_rect(tile_rect), resource_address(resource_address), local_rect(local_rect){}
ClipMaskInstanceImage(ClipMaskInstanceCommon_scalar base, RectWithEndpoint_scalar tile_rect, ivec2_scalar resource_address, RectWithEndpoint_scalar local_rect):base(base),tile_rect(tile_rect),resource_address(resource_address),local_rect(local_rect){
}
IMPLICIT ClipMaskInstanceImage(ClipMaskInstanceImage_scalar s):base(s.base),tile_rect(s.tile_rect),resource_address(s.resource_address),local_rect(s.local_rect){
}
friend ClipMaskInstanceImage if_then_else(I32 c, ClipMaskInstanceImage t, ClipMaskInstanceImage e) { return ClipMaskInstanceImage(
if_then_else(c, t.base, e.base), if_then_else(c, t.tile_rect, e.tile_rect), if_then_else(c, t.resource_address, e.resource_address), if_then_else(c, t.local_rect, e.local_rect));
}};
struct ClipImageVertexInfo_scalar {
vec2_scalar local_pos;
vec4_scalar world_pos;
ClipImageVertexInfo_scalar() = default;
ClipImageVertexInfo_scalar(vec2_scalar local_pos, vec4_scalar world_pos) : local_pos(local_pos), world_pos(world_pos){}
};
struct ClipImageVertexInfo {
vec2 local_pos;
vec4 world_pos;
ClipImageVertexInfo() = default;
ClipImageVertexInfo(vec2 local_pos, vec4 world_pos) : local_pos(local_pos), world_pos(world_pos){}
ClipImageVertexInfo(vec2_scalar local_pos, vec4_scalar world_pos):local_pos(local_pos),world_pos(world_pos){
}
IMPLICIT ClipImageVertexInfo(ClipImageVertexInfo_scalar s):local_pos(s.local_pos),world_pos(s.world_pos){
}
friend ClipImageVertexInfo if_then_else(I32 c, ClipImageVertexInfo t, ClipImageVertexInfo e) { return ClipImageVertexInfo(
if_then_else(c, t.local_pos, e.local_pos), if_then_else(c, t.world_pos, e.world_pos));
}};
ClipMaskInstanceCommon_scalar fetch_clip_item_common() {
 ClipMaskInstanceCommon_scalar cmi;
 (cmi).sub_rect = RectWithEndpoint_scalar((aClipDeviceArea).sel(X, Y), (aClipDeviceArea).sel(Z, W));
 (cmi).task_origin = (aClipOrigins).sel(X, Y);
 (cmi).screen_origin = (aClipOrigins).sel(Z, W);
 (cmi).device_pixel_scale = aDevicePixelScale;
 (cmi).clip_transform_id = (aTransformIds).sel(X);
 (cmi).prim_transform_id = (aTransformIds).sel(Y);
 return cmi;
}
ClipMaskInstanceImage_scalar fetch_clip_item() {
 ClipMaskInstanceImage_scalar cmi;
 (cmi).base = fetch_clip_item_common();
 (cmi).tile_rect = RectWithEndpoint_scalar((aClipTileRect).sel(X, Y), (aClipTileRect).sel(Z, W));
 (cmi).resource_address = aClipDataResourceAddress;
 (cmi).local_rect = RectWithEndpoint_scalar((aClipLocalRect).sel(X, Y), (aClipLocalRect).sel(Z, W));
 return cmi;
}
Transform_scalar fetch_transform(int32_t id) {
 Transform_scalar transform;
 (transform).is_axis_aligned = ((id)>>(24))==(0);
 int32_t index = (id)&(16777215);
 ivec2_scalar uv = make_ivec2(make_int((8u)*((make_uint(index))%((1024u)/(8u)))), make_int((make_uint(index))/((1024u)/(8u))));
 ivec2_scalar uv0 = make_ivec2(((uv).sel(X))+(0), (uv).sel(Y));
 vec4_scalar* sTransformPalette_uv0_fetch = texelFetchPtr(sTransformPalette, uv0, 0, 7, 0, 0);
 (transform).m[0] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 0, 0);
 (transform).m[1] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 1, 0);
 (transform).m[2] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 2, 0);
 (transform).m[3] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 3, 0);
 (transform).inv_m[0] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 4, 0);
 (transform).inv_m[1] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 5, 0);
 (transform).inv_m[2] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 6, 0);
 (transform).inv_m[3] = texelFetchUnchecked(sTransformPalette, sTransformPalette_uv0_fetch, 7, 0);
 return transform;
}
Array<vec4_scalar,2> fetch_from_gpu_cache_2_direct(ivec2_scalar address) {
 vec4_scalar* sGpuCache_address_fetch = texelFetchPtr(sGpuCache, address, 0, 1, 0, 0);
 return Array<vec4_scalar,2>{{texelFetchUnchecked(sGpuCache, sGpuCache_address_fetch, 0, 0), texelFetchUnchecked(sGpuCache, sGpuCache_address_fetch, 1, 0)}};
}
ImageSource_scalar fetch_image_source_direct(ivec2_scalar address) {
 Array<vec4_scalar,2> data = fetch_from_gpu_cache_2_direct(address);
 RectWithEndpoint_scalar uv_rect = RectWithEndpoint_scalar((data[0]).sel(X, Y), (data[0]).sel(Z, W));
 return ImageSource_scalar(uv_rect, data[1]);
}
vec2 rect_clamp(RectWithEndpoint_scalar rect, vec2 pt) {
 return clamp(pt, (rect).p0, (rect).p1);
}
void init_transform_vs(vec4_scalar local_bounds) {
 vTransformBounds = local_bounds;
}
ClipImageVertexInfo write_clip_image_vertex(RectWithEndpoint_scalar tile_rect, RectWithEndpoint_scalar local_clip_rect, Transform_scalar prim_transform, Transform_scalar clip_transform, RectWithEndpoint_scalar sub_rect, vec2_scalar task_origin, vec2_scalar screen_origin, float device_pixel_scale) {
 vec2 local_pos = rect_clamp(local_clip_rect, mix((tile_rect).p0, (tile_rect).p1, (aPosition).sel(X, Y)));
 vec4 world_pos = ((prim_transform).m)*(make_vec4(local_pos, 0.f, 1.f));
 vec4 final_pos = make_vec4((((world_pos).sel(X, Y))*(device_pixel_scale))+(((task_origin)-(screen_origin))*((world_pos).sel(W))), 0.f, (world_pos).sel(W));
 gl_Position = (uTransform)*(final_pos);
 init_transform_vs((clip_transform).is_axis_aligned ? make_vec4(make_vec2(-(10000000000000000.f)), make_vec2(10000000000000000.f)) : make_vec4((local_clip_rect).p0, (local_clip_rect).p1));
 ClipImageVertexInfo vi = ClipImageVertexInfo(local_pos, world_pos);
 return vi;
}
vec2_scalar rect_size(RectWithEndpoint_scalar rect) {
 return ((rect).p1)-((rect).p0);
}
ALWAYS_INLINE void main(void) {
 ClipMaskInstanceImage_scalar cmi = fetch_clip_item();
 Transform_scalar clip_transform = fetch_transform(((cmi).base).clip_transform_id);
 Transform_scalar prim_transform = fetch_transform(((cmi).base).prim_transform_id);
 ImageSource_scalar res = fetch_image_source_direct((cmi).resource_address);
 ClipImageVertexInfo vi = write_clip_image_vertex((cmi).tile_rect, (cmi).local_rect, prim_transform, clip_transform, ((cmi).base).sub_rect, ((cmi).base).task_origin, ((cmi).base).screen_origin, ((cmi).base).device_pixel_scale);
 vLocalPos = (vi).local_pos;
 vec2 uv = (((vi).local_pos)-(((cmi).tile_rect).p0))/(rect_size((cmi).tile_rect));
 vec2_scalar texture_size = make_vec2(textureSize(sColor0, 0));
 vec4_scalar uv_rect = make_vec4(((res).uv_rect).p0, ((res).uv_rect).p1);
 vClipMaskImageUv = (mix((uv_rect).sel(X, Y), (uv_rect).sel(Z, W), uv))/(texture_size);
 vClipMaskUvInnerRect = ((uv_rect)+(make_vec4(0.5f, 0.5f, -(0.5f), -(0.5f))))/((texture_size).sel(X, Y, X, Y));
}
static void set_uniform_1i(Self *self, int index, int value) {
 if (self->samplers.set_slot(index, value)) return;
 switch (index) {
 case 5:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sGpuCache
  break;
 case 1:
  assert(0); // sRenderTasks
  break;
 case 3:
  assert(0); // sTransformPalette
  break;
 case 4:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 5:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sGpuCache
  break;
 case 1:
  assert(0); // sRenderTasks
  break;
 case 3:
  assert(0); // sTransformPalette
  break;
 case 4:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 5:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sGpuCache
  break;
 case 1:
  assert(0); // sRenderTasks
  break;
 case 3:
  assert(0); // sTransformPalette
  break;
 case 4:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, VertexAttrib *attribs, uint32_t start, int instance, int count) {
 load_attrib(self->aPosition, attribs[self->attrib_locations.aPosition], start, instance, count);
 load_flat_attrib(self->aClipDeviceArea, attribs[self->attrib_locations.aClipDeviceArea], start, instance, count);
 load_flat_attrib(self->aClipOrigins, attribs[self->attrib_locations.aClipOrigins], start, instance, count);
 load_flat_attrib(self->aDevicePixelScale, attribs[self->attrib_locations.aDevicePixelScale], start, instance, count);
 load_flat_attrib(self->aTransformIds, attribs[self->attrib_locations.aTransformIds], start, instance, count);
 load_flat_attrib(self->aClipTileRect, attribs[self->attrib_locations.aClipTileRect], start, instance, count);
 load_flat_attrib(self->aClipDataResourceAddress, attribs[self->attrib_locations.aClipDataResourceAddress], start, instance, count);
 load_flat_attrib(self->aClipLocalRect, attribs[self->attrib_locations.aClipLocalRect], start, instance, count);
}
public:
struct InterpOutputs {
vec2_scalar vLocalPos;
vec2_scalar vClipMaskImageUv;
};
private:
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vLocalPos = get_nth(vLocalPos, n);
    dest->vClipMaskImageUv = get_nth(vClipMaskImageUv, n);
    dest_ptr += stride;
  }
}
static void run(Self* self, char* interps, size_t interp_stride) {
 self->main();
 self->store_interp_outputs(interps, interp_stride);
}
static void init_batch(Self *self) { self->bind_textures(); }
public:
cs_clip_image_TEXTURE_2D_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&init_batch;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_primitive_func = (RunPrimitiveFunc)&run;
}
};


struct cs_clip_image_TEXTURE_2D_frag : FragmentShaderImpl, cs_clip_image_TEXTURE_2D_vert {
private:
typedef cs_clip_image_TEXTURE_2D_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
// sampler2D sColor0;
// sampler2D sColor1;
// sampler2D sColor2;
struct RectWithSize_scalar {
vec2_scalar p0;
vec2_scalar size;
RectWithSize_scalar() = default;
RectWithSize_scalar(vec2_scalar p0, vec2_scalar size) : p0(p0), size(size){}
};
struct RectWithSize {
vec2 p0;
vec2 size;
RectWithSize() = default;
RectWithSize(vec2 p0, vec2 size) : p0(p0), size(size){}
RectWithSize(vec2_scalar p0, vec2_scalar size):p0(p0),size(size){
}
IMPLICIT RectWithSize(RectWithSize_scalar s):p0(s.p0),size(s.size){
}
friend RectWithSize if_then_else(I32 c, RectWithSize t, RectWithSize e) { return RectWithSize(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.size, e.size));
}};
struct RectWithEndpoint_scalar {
vec2_scalar p0;
vec2_scalar p1;
RectWithEndpoint_scalar() = default;
RectWithEndpoint_scalar(vec2_scalar p0, vec2_scalar p1) : p0(p0), p1(p1){}
};
struct RectWithEndpoint {
vec2 p0;
vec2 p1;
RectWithEndpoint() = default;
RectWithEndpoint(vec2 p0, vec2 p1) : p0(p0), p1(p1){}
RectWithEndpoint(vec2_scalar p0, vec2_scalar p1):p0(p0),p1(p1){
}
IMPLICIT RectWithEndpoint(RectWithEndpoint_scalar s):p0(s.p0),p1(s.p1){
}
friend RectWithEndpoint if_then_else(I32 c, RectWithEndpoint t, RectWithEndpoint e) { return RectWithEndpoint(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.p1, e.p1));
}};
// sampler2D sGpuCache;
// vec4_scalar vTransformBounds;
vec2 vLocalPos;
vec2 vClipMaskImageUv;
// vec4_scalar vClipMaskUvInnerRect;
Float point_inside_rect(vec2 p, vec2_scalar p0, vec2_scalar p1) {
 vec2 s = (step(p0, p))-(step(p1, p));
 return ((s).sel(X))*((s).sel(Y));
}
Float init_transform_rough_fs(vec2 local_pos) {
 return point_inside_rect(local_pos, (vTransformBounds).sel(X, Y), (vTransformBounds).sel(Z, W));
}
ALWAYS_INLINE void main(void) {
 Float alpha = init_transform_rough_fs(vLocalPos);
 vec2 source_uv = clamp(vClipMaskImageUv, (vClipMaskUvInnerRect).sel(X, Y), (vClipMaskUvInnerRect).sel(Z, W));
 Float clip_alpha = (texture(sColor0, source_uv)).sel(R);
 oFragColor = make_vec4(mix(1.f, clip_alpha, alpha), 0.f, 0.f, 1.f);
}
bool has_valid_transform_bounds() {
 return ((vTransformBounds).sel(W))<(1000000000000000.f);
}
void swgl_drawSpanR8() {
 if (has_valid_transform_bounds()) {
  {
   return;
  }
 }
 swgl_commitTextureLinearR8(sColor0, vClipMaskImageUv, vClipMaskUvInnerRect);
}
typedef cs_clip_image_TEXTURE_2D_vert::InterpOutputs InterpInputs;
InterpInputs interp_step;
struct InterpPerspective {
vec2 vLocalPos;
vec2 vClipMaskImageUv;
};
InterpPerspective interp_perspective;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step) {
  self->vLocalPos = init_interp(init->vLocalPos, step->vLocalPos);
  self->interp_step.vLocalPos = step->vLocalPos * 4.0f;
  self->vClipMaskImageUv = init_interp(init->vClipMaskImageUv, step->vClipMaskImageUv);
  self->interp_step.vClipMaskImageUv = step->vClipMaskImageUv * 4.0f;
}
static void read_perspective_inputs(Self *self, const InterpInputs *init, const InterpInputs *step) {
  Float w = 1.0f / self->gl_FragCoord.w;
  self->interp_perspective.vLocalPos = init_interp(init->vLocalPos, step->vLocalPos);
  self->vLocalPos = self->interp_perspective.vLocalPos * w;
  self->interp_step.vLocalPos = step->vLocalPos * 4.0f;
  self->interp_perspective.vClipMaskImageUv = init_interp(init->vClipMaskImageUv, step->vClipMaskImageUv);
  self->vClipMaskImageUv = self->interp_perspective.vClipMaskImageUv * w;
  self->interp_step.vClipMaskImageUv = step->vClipMaskImageUv * 4.0f;
}
ALWAYS_INLINE void step_interp_inputs(int steps = 4) {
  float chunks = steps * 0.25f;
  vLocalPos += interp_step.vLocalPos * chunks;
  vClipMaskImageUv += interp_step.vClipMaskImageUv * chunks;
}
ALWAYS_INLINE void step_perspective_inputs(int steps = 4) {
  step_perspective(steps);
  float chunks = steps * 0.25f;
  Float w = 1.0f / gl_FragCoord.w;
  interp_perspective.vLocalPos += interp_step.vLocalPos * chunks;
  vLocalPos = w * interp_perspective.vLocalPos;
  interp_perspective.vClipMaskImageUv += interp_step.vClipMaskImageUv * chunks;
  vClipMaskImageUv = w * interp_perspective.vClipMaskImageUv;
}
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int steps) {
 self->step_interp_inputs(steps);
}
static void run_perspective(Self *self) {
 self->main();
 self->step_perspective_inputs();
}
static void skip_perspective(Self* self, int steps) {
 self->step_perspective_inputs(steps);
}
static int draw_span_R8(Self* self) { DISPATCH_DRAW_SPAN(self, R8); }
public:
cs_clip_image_TEXTURE_2D_frag() {
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 draw_span_R8_func = (DrawSpanR8Func)&draw_span_R8;
 enable_perspective();
 init_span_w_func = (InitSpanWFunc)&read_perspective_inputs;
 run_w_func = (RunWFunc)&run_perspective;
 skip_w_func = (SkipWFunc)&skip_perspective;
}
};

struct cs_clip_image_TEXTURE_2D_program : ProgramImpl, cs_clip_image_TEXTURE_2D_frag {
int get_uniform(const char *name) const override {
 if (strcmp("sColor0", name) == 0) { return 5; }
 if (strcmp("sGpuCache", name) == 0) { return 2; }
 if (strcmp("sRenderTasks", name) == 0) { return 1; }
 if (strcmp("sTransformPalette", name) == 0) { return 3; }
 if (strcmp("uTransform", name) == 0) { return 4; }
 return -1;
}
void bind_attrib(const char* name, int index) override {
 attrib_locations.bind_loc(name, index);
}
int get_attrib(const char* name) const override {
 return attrib_locations.get_loc(name);
}
size_t interpolants_size() const override { return sizeof(InterpOutputs); }
VertexShaderImpl* get_vertex_shader() override {
 return this;
}
FragmentShaderImpl* get_fragment_shader() override {
 return this;
}
const char* get_name() const override { return "cs_clip_image_TEXTURE_2D"; }
static ProgramImpl* loader() { return new cs_clip_image_TEXTURE_2D_program; }
};

